package com.jelurida.ardor.contracts;

import nxt.addons.AbstractContract;
import nxt.addons.DelegatedContext;

import java.util.Map;
import java.util.Random;

public class DistributedRandomNumberGenerator<T,R> extends AbstractContract<T,R> {

    @Override
    public R processInvocation(DelegatedContext context, T data) {
        Random random = context.getRandom();
        return processInvocationImpl(random, data);
    }

    public R processInvocationImpl(Random random, T data) {
        Map<String, Long> collect = (Map<String, Long>)data;
        double sum = collect.values().stream().mapToDouble(v -> v).sum();
        double runningSum = 0;
        double value = random.nextDouble();
        for (String account : collect.keySet()) {
            runningSum += collect.get(account);
            if (value <= runningSum / sum) {
                return (R)account;
            }
        }
        return null; // Should never happen unless collection is empty
    }
}
